//                              -*- Mode: C++ -*- 
// Q-element.hh --- Query-element: internal representation for queries' results
// Author          : Nicolas Anquetil
// Created On      : Mon Aug 18 10:45:46 1997
// 


# ifndef Q_ELEMENT_H
# define Q_ELEMENT_H
# define NULLKEY -1

extern "C" {
# include "options.h"
}

# include "read-API.hh"


/* data structure for query elements */
class Qelement {
// --------------------------------------------------
protected:
  char   *_qName;
  class_t _qClass;
  int     _useKey;
  int     _defKey;

public:
  Qelement( char *n, class_t c, int uk = NULLKEY, int dk = NULLKEY) { 
    _qName = n; _qClass = c; _useKey = uk, _defKey = dk;
  };
  Qelement( SoftwareObject *so) {
    _qName = so->objectName();
    _qClass = so->classType(); 
    if (isCdbReferenceClass(_qClass)) {
      _useKey = so->objectKey();
      _defKey = NULLKEY;
    }
    else {
      _defKey = so->objectKey();
      _useKey = NULLKEY;
    }
  };

  char   *qName()  { return( _qName); };
  class_t qClass() { return( _qClass); };
  int    useKey() { return( _useKey); }
  int    defKey() { return( _defKey); }


  bool compatible( char*, class_t);
  bool compatible( SoftwareObject*);
  bool compatible( Qelement*);

  void merge( SoftwareObject*);
  void merge( Qelement*);

  VoidIterator<SoftwareObject*> *getObjectList();
  VoidIterator<SoftwareObject*> *getObjectList(class_t);

  SoftwareObject *getUseObject();
  SoftwareObject *getDefObject();


  void print();
};

bool      compatibleSO(SoftwareObject*, SoftwareObject*);
int       qeltCmp(  Qelement*, Qelement*);
Qelement *qeltMerge(Qelement*, Qelement*);



# endif
